local L = AceLibrary("AceLocale-2.2"):new("EnchantingSell")
local ESUtil = AceLibrary("EnchantingSell-Util-1.0")
local ESD = AceLibrary("EnchantingSell-Debug-1.0")

ES_tester = {
	Locales = {},
	EnchantListData = {},
	EnchantLines = 10,
	All = "All",	--temp
	SelectedEnchant = nil,
}

ES_tester.OnLoad = function ()
	ES_tester.Print("OnLoad");
	for i=1,50 do ES_tester.ScrollData[i] = "Test "..i; end
end

ES_tester.OnEvent = function(...)
	local event, arg = select(2, ...)
	if (event == "ADDON_LOADED") then
		if (string.lower(arg) == "enchantingsell") then
			ES_tester.OnLoad()
		end
	end
end

ES_tester.Print = function (text)
--	DEFAULT_CHAT_FRAME:AddMessage(text);
--	ESD:init()
--	ESD:showDebugFrame()
--	ESD:addLine(text)
end

ES_tester.DropDownArmorInitialise = function ()
	UIDropDownMenu_SetText(ES_tester.All, ES_tester.EFrame.DropDownArmor);

	local dropDownInfo = UIDropDownMenu_CreateInfo();

	--set the first button added to All
	dropDownInfo.text = ES_tester.All;
	dropDownInfo.value = ES_tester.All;
	dropDownInfo.checked = nil;
	dropDownInfo.func = ES_tester.DropDownArmorOnClick;
	dropDownInfo.disabled = nil;
	dropDownInfo.textR = 1;
	dropDownInfo.textG = 1;
	dropDownInfo.textB = 1;
	dropDownInfo.hasColorSwatch = nil;  --added since the color swatches were being displayed randomly. appears info is global variable, so we may need to reset other variables.
	dropDownInfo.notClickable = nil;

	UIDropDownMenu_AddButton(dropDownInfo);
	
	--then create and add all the other buttons for the other armor
	for i, armor in ipairs(L["ARMOR_TYPES"]) do
		dropDownInfo.text = armor[2];
		dropDownInfo.value = armor[2];
		dropDownInfo.checked = nil;
		dropDownInfo.hasColorSwatch = nil;  --added since the color swatches were being displayed randomly. appears info is global variable, so we may need to reset other variables.
		dropDownInfo.func = ES_tester.DropDownArmorOnClick;
		dropDownInfo.disabled = nil;
		dropDownInfo.textR = 1;
		dropDownInfo.textG = 1;
		dropDownInfo.textB = 1;
		dropDownInfo.notClickable = nil;
		
		UIDropDownMenu_AddButton(dropDownInfo);
	end
end

ES_tester.DropDownArmorOnClick = function ()
	UIDropDownMenu_SetText(this.value, ES_tester.EFrame.DropDownArmor);
end

ES_tester.UpdateSortFilter = function ()

end

ES_tester.RefreshEnchantTable = function ()
	ES_tester.Print("RefreshEnchantTable called");
	ES_tester.EnchantListData={};
	ES_tester.EnchantListData = ESUtil:copyTable(ES_tester.EnchantListData, ESeller.db.realm.EnchantList);
	ES_tester.EnchantScrollBar_Update();
end

--ES_tester.SetEnchantTable = function (value)
--	ES_tester.EnchantListData = ESUtil:copyTable(ES_tester.EnchantListData, value);
--	ES_tester.EnchantScrollBar_Update();
--
--end

ES_tester.EnchantScrollBar_Update = function ()
	local line;
	local lineplusoffset; -- an index into our data calculated from the scroll offset
	local enchantCount = getn(ES_tester.EnchantListData);

	ES_tester.Print("enchantCount is "..enchantCount);

	FauxScrollFrame_Update(ES_tester.EFrame.EnchantScrollBar, #ES_tester.EnchantListData, ES_tester.EnchantLines, 16);

	for line=1,ES_tester.EnchantLines do
		lineplusoffset = line + FauxScrollFrame_GetOffset(ES_testerEFrameEnchantScrollBar);
		if lineplusoffset == ES_tester.SelectedEnchant then
			getglobal("ES_testerEFrameEnchantScrollBar"..line):LockHighlight();
		else
			getglobal("ES_testerEFrameEnchantScrollBar"..line):UnlockHighlight();
		end

		if lineplusoffset <= #ES_tester.EnchantListData then
			ES_tester.Print("lineplusoffset is <= to enchantCount"..lineplusoffset.."<="..enchantCount);
			
			getglobal("ES_testerEFrameEnchantScrollBar"..line.."_MakeCount"):SetText(lineplusoffset);
			getglobal("ES_testerEFrameEnchantScrollBar"..line.."_OnThis"):SetText(ES_tester.EnchantListData[lineplusoffset].OnThis);
			getglobal("ES_testerEFrameEnchantScrollBar"..line.."_Name"):SetText(ES_tester.EnchantListData[lineplusoffset].Quality);

			local bonus=ES_tester.EnchantListData[lineplusoffset].Bonus
			local bonusNb=ES_tester.EnchantListData[lineplusoffset].BonusNb
			local completeBonus=bonus
			if bonusNb then
				completeBonus = completeBonus.." +"..bonusNb;
			end
			getglobal("ES_testerEFrameEnchantScrollBar"..line.."_Bonus"):SetText(completeBonus);

			getglobal("ES_testerEFrameEnchantScrollBar"..line.."_PriceGold"):SetText("120");
			getglobal("ES_testerEFrameEnchantScrollBar"..line.."_PriceSilver"):SetText("10");
			getglobal("ES_testerEFrameEnchantScrollBar"..line.."_PriceCopper"):SetText("01");
	
			local chatText=ES_tester.EnchantListData[lineplusoffset].Link;
--			if EnchantingSell_PlayerConfig.EnchanteChatPrice and price and price ~= 0 then
--				local money=abacus:FormatMoneyFull(price);
--				DebugMessage("Money formatted from abacus "..money);
--				chatText = ("{ "..chatText..ENCHANTINGSELL_ENCHANTE_TOOLTIP_SEPARATORFORPRICE..money.." }");
--			end

			--for linking in chat
			getglobal("ES_testerEFrameEnchantScrollBar"..line).ChatTextForAdd = chatText;

			--for tooltip onenter
			ES_tester.EFrame.EnchantButton[line].tooltip=ES_tester.EnchantListData[lineplusoffset].Link;
			ES_tester.EFrame.EnchantButton[line]:Show();
		else
			ES_tester.EFrame.EnchantButton[line]:Hide();
		end
	end
end


ES_tester.CreateFrames = function ()
	ES_tester.Frame = CreateFrame("Frame")
	ES_tester.Frame:RegisterEvent("ADDON_LOADED")
	ES_tester.Frame:SetScript("OnEvent", ES_tester.OnEvent)

	ES_tester.EFrame = CreateFrame("Frame", "ES_tester.EFrame", UIParent)
	ES_tester.EFrame:Hide()
	ES_tester.EFrame:SetPoint("TOP", "UIParent", "TOP", 0, -100)
	ES_tester.EFrame:SetFrameStrata("DIALOG")
	ES_tester.EFrame:SetHeight(512)
	ES_tester.EFrame:SetWidth(420)
	ES_tester.EFrame:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 32, edgeSize = 32,
		insets = { left = 9, right = 9, top = 9, bottom = 9 }
	})
	ES_tester.EFrame:SetBackdropColor(0,0,0, 0.8)
	ES_tester.EFrame:SetMovable(true)

	ES_tester.EFrame.Drag = CreateFrame("Button", "", ES_tester.EFrame)
	ES_tester.EFrame.Drag:SetPoint("TOPLEFT", ES_tester.EFrame, "TOPLEFT", 10,-5)
	ES_tester.EFrame.Drag:SetPoint("TOPRIGHT", ES_tester.EFrame, "TOPRIGHT", -10,-5)
	ES_tester.EFrame.Drag:SetHeight(6)
	ES_tester.EFrame.Drag:SetHighlightTexture("Interface\\FriendsFrame\\UI-FriendsFrame-HighlightBar")
	ES_tester.EFrame.Drag:SetScript("OnMouseDown", function() ES_tester.EFrame:StartMoving() end)
	ES_tester.EFrame.Drag:SetScript("OnMouseUp", function() ES_tester.EFrame:StopMovingOrSizing() end)

	ES_tester.EFrame.TitleText = ES_tester.EFrame:CreateFontString("ES_testerEFrameTitleText", "HIGH", GameFontHighlight)
	ES_tester.EFrame.TitleText:SetPoint("TOP", ES_tester.EFrame, "TOP",0,-10)
	ES_tester.EFrame.TitleText:SetFont("Fonts\\FRIZQT__.TTF",13)
	ES_tester.EFrame.TitleText:SetWidth(420)
	ES_tester.EFrame.TitleText:SetHeight(14)
	ES_tester.EFrame.TitleText:SetJustifyH("CENTER")
	ES_tester.EFrame.TitleText:SetText(L["Enchanting Seller"])
	ES_tester.EFrame.TitleText:Show()

	ES_tester.EFrame.CloseButton = CreateFrame("Button", "", ES_tester.EFrame, "UIPanelCloseButton")
	ES_tester.EFrame.CloseButton:SetPoint("TOPRIGHT", ES_tester.EFrame, "TOPRIGHT")
	ES_tester.EFrame.CloseButton:SetFrameLevel(ES_tester.EFrame:GetFrameLevel()+4)

	ES_tester.EFrame.EnchanterName = ES_tester.EFrame:CreateFontString("ES_testerEFrameEnchanterName", "HIGH", GameFontNormal)
	ES_tester.EFrame.EnchanterName:SetPoint("TOP", ES_tester.EFrame.TitleText, "BOTTOM")
	ES_tester.EFrame.EnchanterName:SetFont("Fonts\\FRIZQT__.TTF",13)
	ES_tester.EFrame.EnchanterName:SetWidth(200)
	ES_tester.EFrame.EnchanterName:SetHeight(14)
	ES_tester.EFrame.EnchanterName:SetText("Beldarp")

	ES_tester.EFrame.DropDownArmor = CreateFrame("Frame", "ES_tester.EFrame.DropDownArmor", ES_tester.EFrame, "UIDropDownMenuTemplate")
	ES_tester.EFrame.DropDownArmor:SetPoint("TOPRIGHT", ES_tester.EFrame, "TOPRIGHT",0,-40)
	UIDropDownMenu_Initialize(ES_tester.EFrame.DropDownArmor, ES_tester.DropDownArmorInitialise);
	UIDropDownMenu_SetWidth(80, ES_tester.EFrame.DropDownArmor)
	UIDropDownMenu_SetButtonWidth(20, ES_tester.EFrame.DropDownArmor) 

	ES_tester.EFrame.DropDownArmorText = ES_tester.EFrame:CreateFontString("ES_testerEFrameDropDownArmorText", "HIGH", GameFontNormalSmall)
	ES_tester.EFrame.DropDownArmorText:SetPoint("BOTTOMRIGHT", ES_tester.EFrame.DropDownArmor, "TOPRIGHT",0,-5)
	ES_tester.EFrame.DropDownArmorText:SetFont("Fonts\\FRIZQT__.TTF",10)
	ES_tester.EFrame.DropDownArmorText:SetWidth(100)
	ES_tester.EFrame.DropDownArmorText:SetHeight(22)
	ES_tester.EFrame.DropDownArmorText:SetJustifyH("LEFT")
	ES_tester.EFrame.DropDownArmorText:SetText(L["Filter By Armor"])
	ES_tester.EFrame.DropDownArmorText:Show()


	ES_tester.EFrame.CraftCreateButton = CreateFrame("Button", "", ES_tester.EFrame, "UIPanelButtonTemplate")
	ES_tester.EFrame.CraftCreateButton:SetPoint("BOTTOMRIGHT", ES_tester.EFrame, "BOTTOMRIGHT",-10,10)
	ES_tester.EFrame.CraftCreateButton:SetWidth(80)
	ES_tester.EFrame.CraftCreateButton:SetHeight(22)
	ES_tester.EFrame.CraftCreateButton:SetText(L["Enchant"])
	ES_tester.EFrame.CraftCreateButton:SetScript("OnClick", function() 
		ES_tester.DoCraft()
	end)

	ES_tester.EFrame.HaveMatsCheckButton = CreateFrame("CheckButton", "", ES_tester.EFrame, "OptionsCheckButtonTemplate")
	ES_tester.EFrame.HaveMatsCheckButton:SetPoint("TOPLEFT", ES_tester.EFrame, "TOPLEFT",10,-40)
	ES_tester.EFrame.HaveMatsCheckButton:SetWidth(22)
	ES_tester.EFrame.HaveMatsCheckButton:SetHeight(22)

	ES_tester.EFrame.HaveMatsCheckButtonText = ES_tester.EFrame:CreateFontString("ES_testerEFrameHaveMatsCheckButtonText", "HIGH", GameFontNormalSmall)
	ES_tester.EFrame.HaveMatsCheckButtonText:SetPoint("BOTTOMLEFT", ES_tester.EFrame.HaveMatsCheckButton, "BOTTOMRIGHT")
	ES_tester.EFrame.HaveMatsCheckButtonText:SetFont("Fonts\\FRIZQT__.TTF",10)
	ES_tester.EFrame.HaveMatsCheckButtonText:SetWidth(100)
	ES_tester.EFrame.HaveMatsCheckButtonText:SetHeight(22)
	ES_tester.EFrame.HaveMatsCheckButtonText:SetJustifyH("LEFT")
	ES_tester.EFrame.HaveMatsCheckButtonText:SetText(L["Have Materials"])
	ES_tester.EFrame.HaveMatsCheckButtonText:Show()

	ES_tester.EFrame.SortByHaveMatsCheckButton = CreateFrame("CheckButton", "", ES_tester.EFrame, "OptionsCheckButtonTemplate")
	ES_tester.EFrame.SortByHaveMatsCheckButton:SetPoint("TOP", ES_tester.EFrame.HaveMatsCheckButton, "BOTTOM",0,5)
	ES_tester.EFrame.SortByHaveMatsCheckButton:SetWidth(22)
	ES_tester.EFrame.SortByHaveMatsCheckButton:SetHeight(22)

	ES_tester.EFrame.SortByHaveMatsCheckButtonText = ES_tester.EFrame:CreateFontString("ES_testerEFrameSortByHaveMatsCheckButtonText", "HIGH", GameFontNormalSmall)
	ES_tester.EFrame.SortByHaveMatsCheckButtonText:SetPoint("BOTTOMLEFT", ES_tester.EFrame.SortByHaveMatsCheckButton, "BOTTOMRIGHT")
	ES_tester.EFrame.SortByHaveMatsCheckButtonText:SetFont("Fonts\\FRIZQT__.TTF",10)
	ES_tester.EFrame.SortByHaveMatsCheckButtonText:SetWidth(100)
	ES_tester.EFrame.SortByHaveMatsCheckButtonText:SetHeight(22)
	ES_tester.EFrame.SortByHaveMatsCheckButtonText:SetJustifyH("LEFT")
	ES_tester.EFrame.SortByHaveMatsCheckButtonText:SetText(L["Sort by feasibility"])
	ES_tester.EFrame.SortByHaveMatsCheckButtonText:Show()

	ES_tester.EFrame.SearchEditBox = CreateFrame("EditBox", "", ES_tester.EFrame, "ES_EditBox_template")
	ES_tester.EFrame.SearchEditBox:SetPoint("TOPLEFT", ES_tester.EFrame.SortByHaveMatsCheckButton, "BOTTOMLEFT",10,0)
	ES_tester.EFrame.SearchEditBox:SetWidth(128)
	ES_tester.EFrame.SearchEditBox:SetHeight(20)
	ES_tester.EFrame.SearchEditBox:SetScript("OnShow", function ()
--		this:SetText(SEARCH)
	end)
	ES_tester.EFrame.SearchEditBox:SetScript("OnEnterPressed", function ()
		this:ClearFocus()
	end)
	ES_tester.EFrame.SearchEditBox:SetScript("OnEscapePressed", function ()
		this:ClearFocus()
	end)
	ES_tester.EFrame.SearchEditBox:SetScript("OnTextChanged", function ()
		ES_tester.SearchEditBox_OnTextChanged();
	end)
	ES_tester.EFrame.SearchEditBox:SetScript("OnEditFocusLost", function ()
		this:HighlightText(0, 0);
		if ( this:GetText() == "" ) then
--			this:SetText(SEARCH);
		end
	end)
	ES_tester.EFrame.SearchEditBox:SetScript("OnEditFocusGained", function ()
		this:HighlightText();
		if ( this:GetText() == SEARCH ) then
--			this:SetText("");
		end
	end)

	ES_tester.ELParent = CreateFrame("Frame", "ES_tester.ELParent", ES_tester.EFrame)
	ES_tester.ELParent:SetPoint("TOPLEFT", ES_tester.EFrame, "TOPLEFT", 5,-110)
	ES_tester.ELParent:SetWidth(380)
	ES_tester.ELParent:SetHeight(170)
	ES_tester.ELParent:SetBackdrop({
		bgFile = "Interface\\AddOns\\BtmScan\\Textures\\Back",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 128, edgeSize = 16,
		insets = { left = 6, right = 6, top = 6, bottom = 6
	}})
	ES_tester.ELParent:Show()

	ES_tester.EFrame.EnchantScrollBar = CreateFrame("ScrollFrame", "ES_testerEFrameEnchantScrollBar", ES_tester.ELParent, "FauxScrollFrameTemplate")
	ES_tester.EFrame.EnchantScrollBar:SetPoint("TOPLEFT", ES_tester.ELParent, "TOPLEFT",0,-5)
	ES_tester.EFrame.EnchantScrollBar:SetPoint("BOTTOMRIGHT", ES_tester.ELParent, "BOTTOMRIGHT")
	ES_tester.EFrame.EnchantScrollBar:SetScript("OnVerticalScroll", function ()
		FauxScrollFrame_OnVerticalScroll(16, ES_tester.EnchantScrollBar_Update)
	end)
	ES_tester.EFrame.EnchantScrollBar:SetScript("OnShow", function() 
		ES_tester.EnchantScrollBar_Update()
	end)

	local tooltip = L["Header tooltip"];
	ES_tester.EFrame.HeaderArmor = CreateFrame("Button", "ES_testerEFrameHeaderArmor", ES_tester.EFrame)
	ES_tester.EFrame.HeaderArmor:SetPoint("BOTTOMLEFT", ES_tester.EFrame.EnchantScrollBar, "TOPLEFT",28,0)
	ES_tester.EFrame.HeaderArmor:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	ES_tester.EFrame.HeaderArmor:SetWidth(53)
	ES_tester.EFrame.HeaderArmor:SetHeight(16)
	ES_tester.EFrame.HeaderArmor:Show();
	ES_tester.EFrame.HeaderArmorFont = ES_tester.EFrame.HeaderArmor:CreateFontString("HeaderArmorFontText", "BORDER", "GameFontNormalSmall")	
	ES_tester.EFrame.HeaderArmorFont:SetPoint("LEFT", 0, 0)		
	ES_tester.EFrame.HeaderArmorFont:SetText("Armor")
	ES_tester.EFrame.HeaderArmor:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this,"ANCHOR_RIGHT")
		GameTooltip:SetText(tooltip)
		GameTooltip:Show();
	end)
	ES_tester.EFrame.HeaderArmor:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	ES_tester.EFrame.HeaderArmor:SetScript("OnClick", function()
--		SortEnchante(string.sub(this:GetName(), 31));
	end)

	ES_tester.EFrame.HeaderName = CreateFrame("Button", "ES_testerEFrameHeaderName", ES_tester.EFrame)
	ES_tester.EFrame.HeaderName:SetPoint("BOTTOMLEFT", ES_tester.EFrame.HeaderArmor, "BOTTOMRIGHT",0,0)
	ES_tester.EFrame.HeaderName:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	ES_tester.EFrame.HeaderName:SetWidth(53)
	ES_tester.EFrame.HeaderName:SetHeight(16)
	ES_tester.EFrame.HeaderName:Show();
	ES_tester.EFrame.HeaderNameFont = ES_tester.EFrame.HeaderName:CreateFontString("HeaderNameFontText", "BORDER", "GameFontNormalSmall")
	ES_tester.EFrame.HeaderNameFont:SetPoint("LEFT", 0, 0)		
	ES_tester.EFrame.HeaderNameFont:SetText("Name")
	ES_tester.EFrame.HeaderName:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this,"ANCHOR_RIGHT")
		GameTooltip:SetText(tooltip)
		GameTooltip:Show();
	end)
	ES_tester.EFrame.HeaderName:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	ES_tester.EFrame.HeaderName:SetScript("OnClick", function()
--		SortEnchante(string.sub(this:GetName(), 31));
	end)

	ES_tester.EFrame.HeaderBonus = CreateFrame("Button", "ES_testerEFrameHeaderBonus", ES_tester.EFrame)
	ES_tester.EFrame.HeaderBonus:SetPoint("BOTTOMLEFT", ES_tester.EFrame.HeaderName, "BOTTOMRIGHT",98,0)
	ES_tester.EFrame.HeaderBonus:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	ES_tester.EFrame.HeaderBonus:SetWidth(53)
	ES_tester.EFrame.HeaderBonus:SetHeight(16)
	ES_tester.EFrame.HeaderBonus:Show();
	ES_tester.EFrame.HeaderBonusFont = ES_tester.EFrame.HeaderBonus:CreateFontString("HeaderBonusFontText", "BORDER", "GameFontNormalSmall")
	ES_tester.EFrame.HeaderBonusFont:SetPoint("LEFT", 0, 0)		
	ES_tester.EFrame.HeaderBonusFont:SetText("Bonus")
	ES_tester.EFrame.HeaderBonus:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this,"ANCHOR_RIGHT")
		GameTooltip:SetText(tooltip)
		GameTooltip:Show();
	end)
	ES_tester.EFrame.HeaderBonus:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	ES_tester.EFrame.HeaderBonus:SetScript("OnClick", function()
--		SortEnchante(string.sub(this:GetName(), 31));
	end)

	ES_tester.EFrame.HeaderPrice = CreateFrame("Button", "ES_testerEFrameHeaderPrice", ES_tester.EFrame)
	ES_tester.EFrame.HeaderPrice:SetPoint("BOTTOMLEFT", ES_tester.EFrame.HeaderBonus, "BOTTOMRIGHT",40,0)
	ES_tester.EFrame.HeaderPrice:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	ES_tester.EFrame.HeaderPrice:SetWidth(53)
	ES_tester.EFrame.HeaderPrice:SetHeight(16)
	ES_tester.EFrame.HeaderPrice:Show();
	ES_tester.EFrame.HeaderPriceFont = ES_tester.EFrame.HeaderPrice:CreateFontString("HeaderPriceFontText", "BORDER", "GameFontNormalSmall")
	ES_tester.EFrame.HeaderPriceFont:SetPoint("LEFT", 0, 0)		
	ES_tester.EFrame.HeaderPriceFont:SetText("Price")
	ES_tester.EFrame.HeaderPrice:SetScript("OnEnter", function()
		GameTooltip:SetOwner(this,"ANCHOR_RIGHT")
		GameTooltip:SetText(tooltip)
		GameTooltip:Show();
	end)
	ES_tester.EFrame.HeaderPrice:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	ES_tester.EFrame.HeaderPrice:SetScript("OnClick", function()
--		SortEnchante(string.sub(this:GetName(), 31));
	end)

--	ES_testerEFrameEnchantButtonHeader_MakeCount:SetText("");


	MONEYCOLOR = {
		Gold = {0.80, 0.70, 0.25};
		Silver = {0.90, 0.90, 1};
		Copper = {0.70, 0.45, 0.20};
	};

	ES_tester.EFrame.EnchantButton={}
	for i=1, ES_tester.EnchantLines do
		ES_tester.EFrame.EnchantButton[i] = CreateFrame("Button", "ES_testerEFrameEnchantScrollBar"..i, ES_tester.EFrame, "ES_Enchant_EnchantListTemplate")
		if (i==1) then
			ES_tester.EFrame.EnchantButton[i]:SetPoint("TOPLEFT", ES_tester.EFrame.EnchantScrollBar, "TOPLEFT", 8,0)
		else 
			ES_tester.EFrame.EnchantButton[i]:SetPoint("TOPLEFT", ES_tester.EFrame.EnchantButton[i-1], "BOTTOMLEFT")
		end
		ES_tester.EFrame.EnchantButton[i]:SetID(i);
		ES_tester.EFrame.EnchantButton[i]:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
		ES_tester.EFrame.EnchantButton[i]:GetHighlightTexture():SetBlendMode("ADD");
		ES_tester.EFrame.EnchantButton[i]:SetScript("OnClick", function ()
			ES_tester.EnchantListOnClick()
		end)
		ES_tester.EFrame.EnchantButton[i]:SetScript("OnEnter", function()
			if ( this.tooltip ) then
				GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
				GameTooltip:SetHyperlink(this.tooltip)
				GameTooltip:Show()
			end
		end)
		ES_tester.EFrame.EnchantButton[i]:SetScript("OnLeave", function()
			GameTooltip:Hide()	
		end)

		getglobal("ES_testerEFrameEnchantScrollBar"..i.."_PriceGold"):SetTextColor(MONEYCOLOR.Gold[1],MONEYCOLOR.Gold[2],MONEYCOLOR.Gold[3]);
		getglobal("ES_testerEFrameEnchantScrollBar"..i.."_PriceSilver"):SetTextColor(MONEYCOLOR.Silver[1],MONEYCOLOR.Silver[2],MONEYCOLOR.Silver[3]);
		getglobal("ES_testerEFrameEnchantScrollBar"..i.."_PriceCopper"):SetTextColor(MONEYCOLOR.Copper[1],MONEYCOLOR.Copper[2],MONEYCOLOR.Copper[3]);
	end

	ES_tester.EDParent = CreateFrame("Frame", "ES_tester.EDParent", ES_tester.EFrame)
	ES_tester.EDParent:SetPoint("TOPLEFT", ES_tester.ELParent, "BOTTOMLEFT", 0,-5)
	ES_tester.EDParent:SetWidth(380)
	ES_tester.EDParent:SetHeight(170)
	ES_tester.EDParent:SetBackdrop({
		bgFile = "Interface\\AddOns\\BtmScan\\Textures\\Back",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 128, edgeSize = 16,
		insets = { left = 6, right = 6, top = 6, bottom = 6
	}})

end

ES_tester.EnchantListOnClick = function ()
	if ( IsShiftKeyDown() ) then
		addText = this.ChatTextForAdd;
		if ( WIM_EditBoxInFocus and addText) then
			WIM_EditBoxInFocus:Insert(addText);

		elseif ( ChatFrameEditBox:IsVisible() and addText ) then
			ChatFrameEditBox:Insert(addText);
		end
	else
		ES_tester.EnchantListOnLeftClick();
	end
end

ES_tester.EnchantListOnLeftClick = function()
	local index=nil;
	if FauxScrollFrame_GetOffset(ES_testerEFrameEnchantScrollBar) then
		index = this:GetID() + FauxScrollFrame_GetOffset(ES_testerEFrameEnchantScrollBar);
	else
		index = this:GetID();
	end
	
	--store the selected value for updating the EnchantButton later on
	ES_tester.SelectedEnchant=index;
	
	--update the Enchant button to enable or disable
	ES_tester.UpdateEnchantButton();

	--updates for the selected highlight texture
	ES_tester.EnchantScrollBar_Update();	

	--if the Blizzard Enchanting frame is open, then update the selected enchant
	if (CraftFrame:IsShown()) and (GetCraftSkillLine(1)  == L["Enchanting"]) then
			CraftFrame_SetSelection(ES_tester.EnchantListData[ES_tester.SelectedEnchant].IdOriginal);
			CraftFrame_Update();
	end
end

ES_tester.UpdateEnchantButton = function()
--	if (EnchantingSell_Enchante_Frame:IsShown() and ESell_currentEnchantSelected~=nil) then
--		if (EnchantingSell_Config.EnchantePlayerName == EnchantingSell_CourantPlayerName) then
--			local etat = ESell_Enchante_getEtat(ESell_currentEnchantSelected);
--
--			--Etat will be 1 if you can do the chant with items in bags
----			if ESell_Enchante_getEtat(ESell_currentEnchantSelected) == 1 then
--			if (etat > 0 and etat < 4) then
--				EnchantingSell_CraftCreateButton:Enable();
--			else
--				EnchantingSell_CraftCreateButton:Disable();
--			end
--		end
--	end
end

ES_tester.DoCraft = function()
--	if (EnchantingSell_Config.EnchantePlayerName == EnchantingSell_CourantPlayerName) then
		local craftId = ES_tester.EnchantListData[ES_tester.SelectedEnchant].IdOriginal;
		local enchantName = ES_tester.EnchantListData[ES_tester.SelectedEnchant].EnchantName;
--		local name, onThis, bonusType, bonusAdd = ESell_Enchante_getInfoBonus(listIdSelectedEnchante);

--		DEFAULT_CHAT_FRAME:AddMessage("SelectedEnchant is ".. isNullOrValue(ES_tester.SelectedEnchant));
--		DEFAULT_CHAT_FRAME:AddMessage("craftId is ".. isNullOrValue(craftId));
--		DEFAULT_CHAT_FRAME:AddMessage("enchantName is ".. isNullOrValue(enchantName));
--		DEFAULT_CHAT_FRAME:AddMessage("GetCraftInfo(craftId) is ".. isNullOrValue(GetCraftInfo(craftId)));

		--hack incase the local cache of crafting has changed.
		--this prevents DoCraft from functioning properly.
		--as a result, we need to open the default enchanting frame to load the crafts
		--that forces the trade window to close, since too many frames are open.
		--so, we close ES and open/close enchanting.  that prevents the trade frame from closing.
		--i think this is also possible for hunters/warlocks that open pet frame, that are also enchanters. since their frames are considering crafting frames also
		if not (craftId and (enchantName == GetCraftInfo(craftId))) then
--			--close ES
--			Toggle_EnchantingSell();
--			
--			--open/close default enchant frame to refresh local cache
--			CastSpellByName(L["Enchanting"]);CastSpellByName(L["Enchanting"]);
		end
		
		SelectCraft(craftId);
		DoCraft(craftId);
		
--		local completeBonus;
--		if bonusAdd then
--			completeBonus = bonusType.." +"..bonusAdd;
--		else
--			if bonusType then
--				completeBonus = bonusType;
--			end
--		end
--		if completeBonus then completeBonus = " ("..completeBonus..")" else completeBonus = "" end
--		DEFAULT_CHAT_FRAME:AddMessage(enchanteLongName..completeBonus.." sur ...", 0.45, 1, 0.45);
		DEFAULT_CHAT_FRAME:AddMessage("Crafting "..enchantName, 0.45, 1, 0.45);

--		else
--			DEFAULT_CHAT_FRAME:AddMessage("There was a problem performing this enchant.");
--			DEFAULT_CHAT_FRAME:AddMessage(" You may need to refresh your crafting cache.  Please open the default enchanting window and try again.");
--		end
--	else
--		DEFAULT_CHAT_FRAME:AddMessage("You cannot perform this action while viewing another characters enchants.");
--	end
end

ES_tester.CreateEnchantButtonLines = function ()

end

function ES_tester.SearchEditBox_OnTextChanged()
	local text = this:GetText():lower();
	ES_tester.Print("SearchEditBox_OnTextChanged "..text);

	local temp={};
	if (text~="" or text~=nil) then
		ES_tester.RefreshEnchantTable();
		for k,v in ipairs(ES_tester.EnchantListData) do
			local name=ES_tester.EnchantListData[k].EnchantName:lower();
			if (string.find(name, text)) then
				table.insert(temp, v);
				ES_tester.Print("adding "..name);
--				table.remove(ES_tester.EnchantListData, k)
			end
		end	
		ES_tester.EnchantListData=temp;
	end
--	ES_tester.Print("ES_tester.EnchantListData "..getn(ES_tester.EnchantListData));
	ES_tester.EnchantScrollBar_Update()
end

ES_tester.Toggle_EnchantingSell = function(tab)
	if ( not tab ) then
		if ( ES_tester.EFrame:IsVisible() ) then
			HideUIPanel(ES_tester.EFrame);
		else
			ShowUIPanel(ES_tester.EFrame);
--			local selectedFrame = getglobal(ENCHANTINGSELL_TAB_SUBFRAMES[EnchantingSell_Frame.selectedTab]);
--			if ( not selectedFrame:IsVisible() ) then
--				selectedFrame:Show()
--			end
		end
	else
--		local subFrame = getglobal(tab);
--		if ( subFrame ) then
--			PanelTemplates_SetTab(EnchantingSell_Frame, subFrame:GetID());
--			if ( EnchantingSell_Frame:IsVisible() ) then
--				if ( subFrame:IsVisible() ) then
--					HideUIPanel(EnchantingSell_Frame);
--				else
--					PlaySound("igCharacterInfoTab");
--					EnchantingSell_Frame_ShowSubFrame(tab);
--				end
--			else
--				ShowUIPanel(EnchantingSell_Frame);
--				EnchantingSell_Frame_ShowSubFrame(tab);
--			end
--		end
	end
--	ESell_ChangeEnchantePrice_Reset();

	return ES_tester.EFrame:IsVisible();
end